#include "curlpp.hh"

namespace curlpp
{
	void foo() {}
	
	int writefunction(char *data, size_t size, size_t nmemb, Glib::ustring *buffer)
	{
		if(buffer!=NULL)
		{
			buffer->append(data, size*nmemb);
			return size*nmemb;
		}
		return 0;
	}
	
	curl::curl()
	{
		curl_global_init(CURL_GLOBAL_ALL);
		
		handle = curl_easy_init();
	}
	
	curl::~curl()
	{
		curl_easy_cleanup(handle);
	}
	
	CURLcode curl::url(Glib::ustring text)
	{
		return curl_easy_setopt(handle, CURLOPT_URL, text.c_str());
	}
	
	CURLcode curl::post(bool value)
	{
		return curl_easy_setopt(handle, CURLOPT_POST, value);
	}
	
	CURLcode curl::httpheader(Glib::ustring text)
	{
		struct curl_slist *headerlist = NULL;
		
		headerlist = curl_slist_append(headerlist, text.c_str());
		
		return curl_easy_setopt(handle, CURLOPT_HTTPHEADER, headerlist);
	}
	
	CURLcode curl::postfields(Glib::ustring text)
	{
		return curl_easy_setopt(handle, CURLOPT_POSTFIELDS, text.c_str());
	}
	
	CURLcode curl::cookiefile(Glib::ustring text)
	{
		return curl_easy_setopt(handle, CURLOPT_COOKIEFILE, text.c_str());
	}
	
	CURLcode curl::encoding(Glib::ustring text)
	{
		return curl_easy_setopt(handle, CURLOPT_ENCODING, text.c_str());
	}
	
	CURLcode curl::ssl_verifypeer(int value)
	{
		return curl_easy_setopt(handle, CURLOPT_SSL_VERIFYPEER, value);
	}
	
	CURLcode curl::ssl_verifyhost(int value)
	{
		return curl_easy_setopt(handle, CURLOPT_SSL_VERIFYHOST, value);
	}
	
	CURLcode curl::followlocation(bool value)
	{
		return curl_easy_setopt(handle, CURLOPT_FOLLOWLOCATION, value);
	}
	
	CURLcode curl::writenothing()
	{
		return curl_easy_setopt(handle, CURLOPT_WRITEFUNCTION, foo);
	}
	
	void curl::writedata()
	{
		curl_easy_setopt(handle, CURLOPT_WRITEFUNCTION, writefunction);
		curl_easy_setopt(handle, CURLOPT_WRITEDATA, &data);
	}
	
	void curl::perform()
	{
		result = curl_easy_perform(handle);
	}
	
	CURLcode curl::get_result()
	{
		return result;
	}
	
	Glib::ustring curl::get_data()
	{
		return data;
	}
}
