#ifndef CONVMAN_CURLPP_HH
#define CONVMAN_CURLPP_HH

#include <curl/curl.h>
#include <glibmm/ustring.h>

namespace curlpp
{
	class curl
	{
		public:
			curl();
			~curl();
			
			CURLcode url(Glib::ustring);
			CURLcode post(bool);
			CURLcode httpheader(Glib::ustring);
			CURLcode postfields(Glib::ustring);
			CURLcode cookiefile(Glib::ustring);
			CURLcode encoding(Glib::ustring);
			CURLcode ssl_verifypeer(int);
			CURLcode ssl_verifyhost(int);
			CURLcode followlocation(bool);
			CURLcode writenothing();
			void writedata();
			
			void perform();
			
			CURLcode get_result();
			Glib::ustring get_data();
		private:
			CURL *handle;
			CURLcode result;
			
			Glib::ustring data;
	};
}

#endif
